GTPin: gtpin::GtHliParamType Class Reference

GTPin

- Main Page
- Related Pages
- Modules
- Data Structures

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Types | Public Member Functions
gtpin::GtHliParamType Class Reference
GTPin: High-Level Instrumentation (HLI) Parameters and Arguments

Type of an HLI function parameter. More...

`#include <igt_iarg.h>`

## Public Types
enum | ENUM { INVALID, PRIME, PTR }
## Public Member Functions
constexpr | GtHliParamType (ENUM e=INVALID)
| Conversion constructor.
constexpr | operator ENUM () const
| Conversion operator.
constexpr bool | IsValid () const
| Return true for a valid parameter type.
constexpr bool | IsPrime () const
| Return true for a primary parameter type.
constexpr bool | IsPtr () const
| Return true if the parameter is a pointer.
const char * | ToString () const
| Return string representation.

## Detailed Description

Type of an HLI function parameter.

Following are primary HLI parameter types, supported by GTPin:

- Integer i8, i16, i32, i64
- Floating-point f16, f32, f64
- Enumeration

Compound parameter types include:

- Pointer Pointer to a variable in the device (GPU) address space

The type of the function's return value can be any of the above types or void.

- Note:
    The function parameter refer to the variable listed inside the parentheses in the function definition.
    The function argument is the value that is passed to the function when it is called
    The parameter type and the argument type are not always identical, but argument value must be convertible to the corresponding parameter type. The conversion is provided by either compiler or GTPin
- Note:
    HLI function is executed in the context of a GPU device, so all pointer parameters of the function should refer to variables in the device memory. However, for tools that specify function arguments in the host (CPU) space, addresses in the device space are unknown.
    To allow passing pointer arguments to HLI functions, GTPin provides memory mapping services that transparently convert host pointers to device addresses and vice versa. See GTPin: Host-to-Device Memory Mapper for details.
    The memory address mapping is applied to pointer arguments specified by immediate values. Pointers passed in registers are assumed to refer device memory.

## Member Enumeration Documentation

enum gtpin::GtHliParamType::ENUM

Enumerator:

  INVALID | Invalid HLI parameter type.
  PRIME | Primary HLI parameter type: integer, floating-point, enumeration.
  PTR | Pointer to a variable in the device (GPU) address space.

All Data Structures Functions Variables Typedefs Enumerations Enumerator

      Copyright (C) 2013-2025 Intel Corporation

      SPDX-License-Identifier: MIT